/*
 * calculator.h
 *
 * Created: 29.05.2023 12:01:39
 *  Author: mrnek
 */ 


#ifndef CALCULATOR_H_
#define CALCULATOR_H_

enum calculator_state {
	NUMBER_FIRST,
	NUMBER_SECOND,
	RESULT
};
enum calculator_op {
	NO_OP,
	ADD,
	SUB,
	DIV,
	MUL
};
struct calculator {
	// 1 
	long num1;
	// 2 
	long num2;
	// 3 
	enum calculator_op operation;
	// 4 
	long result;
	// 5  
	enum calculator_state state;
};

void clearCalc(struct calculator *calc);

void handleCalc(struct calculator *calc, int input);

#endif /* CALCULATOR_H_ */